# UIRenderer (SubServers.Client.Bukkit)

net.ME1312.SubServers.Client.Bukkit.Graphic

## Class UIRenderer

- java.lang.Object
- - net.ME1312.SubServers.Client.Bukkit.Graphic.UIRenderer

Direct Known Subclasses:
  InternalUIRenderer

    public abstract class UIRenderer
    extends java.lang.Object

GUI Renderer Layout Class

### Nested Class Summary

Nested Classes
`static class` `UIRenderer.CreatorOptions` SubCreator Options Class
`static class` `UIRenderer.Options` Options Layout Class

### Constructor Summary

Constructors
Constructor and Description
`UIRenderer(SubPlugin plugin, java.util.UUID player)` Creates a new UIRenderer

### Method Summary

All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
`static void` `addHostPlugin(java.lang.String handle, Renderer renderer)` Add Host Plugin
`static void` `addSubServerPlugin(java.lang.String handle, Renderer renderer)` Add SubServer Plugin
`abstract void` `back()` Reopens the previous window
`abstract void` `clearHistory()` Clears the Window History
`static java.util.Map<java.lang.String,Renderer>` `getHostPlugins()` Get Host Plugins
`static java.util.Map<java.lang.String,Renderer>` `getSubServerPlugins()` Get SubServer Plugins
`abstract void` `groupMenu(int page)` Opens the Group Menu
`abstract boolean` `hasHistory()` If there is any Window History
`abstract void` `hostAdmin(java.lang.String host)` Opens Host/<name>
`abstract void` `hostCreator(UIRenderer.CreatorOptions options)` Opens Host/<name>/Create
`abstract void` `hostMenu(int page)` Opens the Host Menu
`abstract void` `hostPlugin(int page, java.lang.String host)` Opens Host/<name>/Plugins
`abstract void` `newUI()` Opens a new window
`static void` `removeHostPlugin(java.lang.String handle)` Remove Host Plugin
`static void` `removeSubServerPlugin(java.lang.String handle)` Remove SubServer Plugin
`abstract void` `reopen()` Reopens the current window
`boolean` `sendTitle(java.lang.String str)` Attempt to send a Title Message
`boolean` `sendTitle(java.lang.String str, int stay)` Attempt to send a Title Message
`boolean` `sendTitle(java.lang.String str, int fadein, int stay, int fadeout)` Attempt to send a Title Message
`abstract void` `serverMenu(int page, java.lang.String host, java.lang.String group)` Opens the SubServer Menu
`void` `setDownloading(java.lang.String subtitle)` Shows/Hides the Downloading Title Message
`abstract void` `subserverAdmin(java.lang.String server)` Opens SubServer/<name>
`abstract void` `subserverPlugin(int page, java.lang.String server)` Opens SubServer/<name>/Plugins

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### UIRenderer

    public UIRenderer(SubPlugin plugin,
                      java.util.UUID player)

Creates a new UIRenderer

Parameters:
  `plugin` - SubPlugin
  `player` - Player

### Method Detail

#### newUI

    public abstract void newUI()

Opens a new window

#### clearHistory

    public abstract void clearHistory()

Clears the Window History

#### hasHistory

    public abstract boolean hasHistory()

If there is any Window History

Returns:
  Window History Status

#### reopen

    public abstract void reopen()

Reopens the current window

#### back

    public abstract void back()

Reopens the previous window

#### sendTitle

    public boolean sendTitle(java.lang.String str)

Attempt to send a Title Message

Parameters:
  `str` - Message
Returns:
  Success Status

#### sendTitle

    public boolean sendTitle(java.lang.String str,
                             int stay)

Attempt to send a Title Message

Parameters:
  `str` - Message
  `stay` - How long the message should stay
Returns:
  Success Status

#### sendTitle

    public boolean sendTitle(java.lang.String str,
                             int fadein,
                             int stay,
                             int fadeout)

Attempt to send a Title Message

Parameters:
  `str` - Message
  `fadein` - FadeIn Transition length
  `stay` - How long the message should stay
  `fadeout` - FadeOut Transition length
Returns:
  Success Status

#### setDownloading

    public void setDownloading(java.lang.String subtitle)

Shows/Hides the Downloading Title Message

Parameters:
  `subtitle` - Subtitle to display (or null to hide)

#### addHostPlugin

    public static void addHostPlugin(java.lang.String handle,
                                     Renderer renderer)

Add Host Plugin

Parameters:
  `handle` - Handle to bind
  `renderer` - Renderer

#### getHostPlugins

    public static java.util.Map<java.lang.String,Renderer> getHostPlugins()

Get Host Plugins

Returns:
  Host Plugins

#### removeHostPlugin

    public static void removeHostPlugin(java.lang.String handle)

Remove Host Plugin

Parameters:
  `handle` - Handle

#### addSubServerPlugin

    public static void addSubServerPlugin(java.lang.String handle,
                                          Renderer renderer)

Add SubServer Plugin

Parameters:
  `handle` - Handle to bind
  `renderer` - Renderer

#### getSubServerPlugins

    public static java.util.Map<java.lang.String,Renderer> getSubServerPlugins()

Get SubServer Plugins

Returns:
  SubServer Plugins

#### removeSubServerPlugin

    public static void removeSubServerPlugin(java.lang.String handle)

Remove SubServer Plugin

Parameters:
  `handle` - Handle

#### hostMenu

    public abstract void hostMenu(int page)

Opens the Host Menu

Parameters:
  `page` - Page Number (starting from page 1)

#### hostAdmin

    public abstract void hostAdmin(java.lang.String host)

Opens Host/<name>

Parameters:
  `host` - Host Name

#### hostCreator

    public abstract void hostCreator(UIRenderer.CreatorOptions options)

Opens Host/<name>/Create

Parameters:
  `options` - Creator Options

#### hostPlugin

    public abstract void hostPlugin(int page,
                                    java.lang.String host)

Opens Host/<name>/Plugins

Parameters:
  `host` - Host Name

#### groupMenu

    public abstract void groupMenu(int page)

Opens the Group Menu

Parameters:
  `page` - Page Number (starting from page 1)

#### serverMenu

    public abstract void serverMenu(int page,
                                    java.lang.String host,
                                    java.lang.String group)

Opens the SubServer Menu

Parameters:
  `page` - Page Number (starting from page 1)
  `host` - Host Name (or null to scan all hosts)

#### subserverAdmin

    public abstract void subserverAdmin(java.lang.String server)

Opens SubServer/<name>

Parameters:
  `server` - SubServer Name

#### subserverPlugin

    public abstract void subserverPlugin(int page,
                                         java.lang.String server)

Opens SubServer/<name>/Plugins

Parameters:
  `server` - SubServer Name